/*
 * Arduino Project 2a TDS Sensor
 * Complete Project details https://thediyaquarium.com/
 */
 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2); // I2C address 0x27 , 16 column and 2 rows


 
#define TdsSensorPin A0
int ADC_value;
unsigned long int avgval_ADC;
int buffer_tds[10],temp1;
 
void setup()
{
    Serial.begin(115200);
    pinMode(TdsSensorPin,INPUT);
    lcd.init();
    lcd.backlight();
}
 
void loop()
{
  lcd.clear();
  for(int i=0;i<10;i++) 
  { 
    buffer_tds[i]=analogRead(TdsSensorPin);
    delay(2);
  }
 
    for(int i=0;i<9;i++)
      {
        for(int j=i+1;j<10;j++)
          {
            if(buffer_tds[i]>buffer_tds[j])
              {
                temp1=buffer_tds[i];
                buffer_tds[i]=buffer_tds[j];
                buffer_tds[j]=temp1;
              }
            }
       }
 
      avgval_ADC=0;
      for(int i=2;i<8;i++)
      avgval_ADC+=buffer_tds[i];
      
      float voltage_value = (float)avgval_ADC*5.0/1024.0/6;
      float TDS = (133.42/voltage_value*voltage_value-255.86*voltage_value*voltage_value + 857.39*voltage_value)*0.5;
      lcd.setCursor(0,0);
      lcd.print("       TDS");
      lcd.setCursor(3,1);
      lcd.print(TDS);
      lcd.setCursor(10,1);
      lcd.print("PPM");
      delay(5000);
}
